/* Agent.c generated by valac 0.56.17, the Vala compiler
 * generated from Agent.vala, do not modify */

/*-
 * Copyright (c) 2015-2016 elementary LLC.
 * Copyright (C) 2015-2016 Ikey Doherty <ikey@solus-project.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Adam Bieńkowski <donadigos159@gmail.com>
 */
/*
 * Code based on budgie-desktop:
 * https://github.com/solus-project/budgie-desktop
 */

#include <polkitagent/polkitagent.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <polkit/polkit.h>
#include <granite-7.h>
#include <gtk/gtk.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define AG_TYPE_AGENT (ag_agent_get_type ())
#define AG_AGENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), AG_TYPE_AGENT, AgAgent))
#define AG_AGENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), AG_TYPE_AGENT, AgAgentClass))
#define AG_IS_AGENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), AG_TYPE_AGENT))
#define AG_IS_AGENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), AG_TYPE_AGENT))
#define AG_AGENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), AG_TYPE_AGENT, AgAgentClass))

typedef struct _AgAgent AgAgent;
typedef struct _AgAgentClass AgAgentClass;
typedef struct _AgAgentPrivate AgAgentPrivate;
enum  {
	AG_AGENT_0_PROPERTY,
	AG_AGENT_NUM_PROPERTIES
};
static GParamSpec* ag_agent_properties[AG_AGENT_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block2Data Block2Data;

#define AG_TYPE_POLKIT_DIALOG (ag_polkit_dialog_get_type ())
#define AG_POLKIT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), AG_TYPE_POLKIT_DIALOG, AgPolkitDialog))
#define AG_POLKIT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), AG_TYPE_POLKIT_DIALOG, AgPolkitDialogClass))
#define AG_IS_POLKIT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), AG_TYPE_POLKIT_DIALOG))
#define AG_IS_POLKIT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), AG_TYPE_POLKIT_DIALOG))
#define AG_POLKIT_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), AG_TYPE_POLKIT_DIALOG, AgPolkitDialogClass))

typedef struct _AgPolkitDialog AgPolkitDialog;
typedef struct _AgPolkitDialogClass AgPolkitDialogClass;
typedef struct _AgPolkitDialogPrivate AgPolkitDialogPrivate;
typedef struct _AgAgentInitiateAuthenticationData AgAgentInitiateAuthenticationData;

struct _AgAgent {
	PolkitAgentListener parent_instance;
	AgAgentPrivate * priv;
};

struct _AgAgentClass {
	PolkitAgentListenerClass parent_class;
};

struct _Block2Data {
	int _ref_count_;
	AgAgent* self;
	gpointer _async_data_;
};

struct _AgPolkitDialog {
	GraniteMessageDialog parent_instance;
	AgPolkitDialogPrivate * priv;
	gboolean was_canceled;
};

struct _AgPolkitDialogClass {
	GraniteMessageDialogClass parent_class;
};

struct _AgAgentInitiateAuthenticationData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AgAgent* self;
	gchar* action_id;
	gchar* message;
	gchar* icon_name;
	PolkitDetails* details;
	gchar* cookie;
	GList* identities;
	GCancellable* cancellable;
	gboolean result;
	Block2Data* _data2_;
	AgPolkitDialog* dialog;
	AgPolkitDialog* _tmp0_;
	AgPolkitDialog* _tmp1_;
	AgPolkitDialog* _tmp2_;
	AgPolkitDialog* _tmp3_;
	AgPolkitDialog* _tmp4_;
	GError* _tmp5_;
	GError* _inner_error0_;
};

static gpointer ag_agent_parent_class = NULL;

VALA_EXTERN GType ag_agent_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AgAgent, g_object_unref)
static void ag_agent_real_initiate_authentication_data_free (gpointer _data);
static void ag_agent_real_initiate_authentication (PolkitAgentListener* base,
                                            const gchar* action_id,
                                            const gchar* message,
                                            const gchar* icon_name,
                                            PolkitDetails* details,
                                            const gchar* cookie,
                                            GList* identities,
                                            GCancellable* cancellable,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_);
static gboolean ag_agent_real_initiate_authentication_co (AgAgentInitiateAuthenticationData* _data_);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
VALA_EXTERN GType ag_polkit_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AgPolkitDialog, g_object_unref)
VALA_EXTERN AgPolkitDialog* ag_polkit_dialog_new (const gchar* message,
                                      const gchar* icon_name,
                                      const gchar* _cookie,
                                      GList* _idents,
                                      GCancellable* _cancellable);
VALA_EXTERN AgPolkitDialog* ag_polkit_dialog_construct (GType object_type,
                                            const gchar* message,
                                            const gchar* icon_name,
                                            const gchar* _cookie,
                                            GList* _idents,
                                            GCancellable* _cancellable);
static void __lambda8_ (Block2Data* _data2_);
static void ___lambda8__ag_polkit_dialog_done (AgPolkitDialog* _sender,
                                        gpointer self);
VALA_EXTERN AgAgent* ag_agent_new (void);
VALA_EXTERN AgAgent* ag_agent_construct (GType object_type);
static GType ag_agent_get_type_once (void);

static void
ag_agent_real_initiate_authentication_data_free (gpointer _data)
{
	AgAgentInitiateAuthenticationData* _data_;
	_data_ = _data;
#line 27 "../src/Agent.vala"
	_g_free0 (_data_->action_id);
#line 27 "../src/Agent.vala"
	_g_free0 (_data_->message);
#line 27 "../src/Agent.vala"
	_g_free0 (_data_->icon_name);
#line 27 "../src/Agent.vala"
	_g_object_unref0 (_data_->details);
#line 27 "../src/Agent.vala"
	_g_free0 (_data_->cookie);
#line 27 "../src/Agent.vala"
	_g_object_unref0 (_data_->cancellable);
#line 27 "../src/Agent.vala"
	_g_object_unref0 (_data_->self);
#line 27 "../src/Agent.vala"
	g_slice_free (AgAgentInitiateAuthenticationData, _data_);
#line 197 "Agent.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 27 "../src/Agent.vala"
	return self ? g_object_ref (self) : NULL;
#line 205 "Agent.c"
}

static void
ag_agent_real_initiate_authentication (PolkitAgentListener* base,
                                       const gchar* action_id,
                                       const gchar* message,
                                       const gchar* icon_name,
                                       PolkitDetails* details,
                                       const gchar* cookie,
                                       GList* identities,
                                       GCancellable* cancellable,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_)
{
	AgAgent * self;
	AgAgentInitiateAuthenticationData* _data_;
	AgAgent* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	PolkitDetails* _tmp4_;
	gchar* _tmp5_;
	GCancellable* _tmp6_;
#line 27 "../src/Agent.vala"
	g_return_if_fail (action_id != NULL);
#line 27 "../src/Agent.vala"
	g_return_if_fail (message != NULL);
#line 27 "../src/Agent.vala"
	g_return_if_fail (icon_name != NULL);
#line 27 "../src/Agent.vala"
	g_return_if_fail (details != NULL);
#line 27 "../src/Agent.vala"
	g_return_if_fail (cookie != NULL);
#line 27 "../src/Agent.vala"
	self = (AgAgent*) base;
#line 27 "../src/Agent.vala"
	_data_ = g_slice_new0 (AgAgentInitiateAuthenticationData);
#line 27 "../src/Agent.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 27 "../src/Agent.vala"
	g_task_set_task_data (_data_->_async_result, _data_, ag_agent_real_initiate_authentication_data_free);
#line 27 "../src/Agent.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 27 "../src/Agent.vala"
	_data_->self = _tmp0_;
#line 27 "../src/Agent.vala"
	_tmp1_ = g_strdup (action_id);
#line 27 "../src/Agent.vala"
	_g_free0 (_data_->action_id);
#line 27 "../src/Agent.vala"
	_data_->action_id = _tmp1_;
#line 27 "../src/Agent.vala"
	_tmp2_ = g_strdup (message);
#line 27 "../src/Agent.vala"
	_g_free0 (_data_->message);
#line 27 "../src/Agent.vala"
	_data_->message = _tmp2_;
#line 27 "../src/Agent.vala"
	_tmp3_ = g_strdup (icon_name);
#line 27 "../src/Agent.vala"
	_g_free0 (_data_->icon_name);
#line 27 "../src/Agent.vala"
	_data_->icon_name = _tmp3_;
#line 27 "../src/Agent.vala"
	_tmp4_ = _g_object_ref0 (details);
#line 27 "../src/Agent.vala"
	_g_object_unref0 (_data_->details);
#line 27 "../src/Agent.vala"
	_data_->details = _tmp4_;
#line 27 "../src/Agent.vala"
	_tmp5_ = g_strdup (cookie);
#line 27 "../src/Agent.vala"
	_g_free0 (_data_->cookie);
#line 27 "../src/Agent.vala"
	_data_->cookie = _tmp5_;
#line 27 "../src/Agent.vala"
	_data_->identities = identities;
#line 27 "../src/Agent.vala"
	_tmp6_ = _g_object_ref0 (cancellable);
#line 27 "../src/Agent.vala"
	_g_object_unref0 (_data_->cancellable);
#line 27 "../src/Agent.vala"
	_data_->cancellable = _tmp6_;
#line 27 "../src/Agent.vala"
	ag_agent_real_initiate_authentication_co (_data_);
#line 291 "Agent.c"
}

static gboolean
ag_agent_initiate_authentication_finish (PolkitAgentListener* base,
                                         GAsyncResult* _res_,
                                         GError** error)
{
	gboolean result;
	AgAgentInitiateAuthenticationData* _data_;
#line 27 "../src/Agent.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 27 "../src/Agent.vala"
	if (NULL == _data_) {
#line 305 "Agent.c"
		gboolean _tmp0_ = FALSE;
#line 27 "../src/Agent.vala"
		return _tmp0_;
#line 309 "Agent.c"
	}
#line 27 "../src/Agent.vala"
	result = _data_->result;
#line 27 "../src/Agent.vala"
	return result;
#line 315 "Agent.c"
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 28 "../src/Agent.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 28 "../src/Agent.vala"
	return _data2_;
#line 325 "Agent.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 28 "../src/Agent.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 335 "Agent.c"
		AgAgent* self;
#line 28 "../src/Agent.vala"
		self = _data2_->self;
#line 28 "../src/Agent.vala"
		_g_object_unref0 (self);
#line 28 "../src/Agent.vala"
		g_slice_free (Block2Data, _data2_);
#line 343 "Agent.c"
	}
}

static void
__lambda8_ (Block2Data* _data2_)
{
	AgAgent* self;
#line 35 "../src/Agent.vala"
	self = _data2_->self;
#line 35 "../src/Agent.vala"
	ag_agent_real_initiate_authentication_co (_data2_->_async_data_);
#line 355 "Agent.c"
}

static void
___lambda8__ag_polkit_dialog_done (AgPolkitDialog* _sender,
                                   gpointer self)
{
#line 35 "../src/Agent.vala"
	__lambda8_ (self);
#line 364 "Agent.c"
}

static gboolean
ag_agent_real_initiate_authentication_co (AgAgentInitiateAuthenticationData* _data_)
{
#line 28 "../src/Agent.vala"
	switch (_data_->_state_) {
#line 28 "../src/Agent.vala"
		case 0:
#line 374 "Agent.c"
		goto _state_0;
#line 28 "../src/Agent.vala"
		case 1:
#line 378 "Agent.c"
		goto _state_1;
		default:
#line 28 "../src/Agent.vala"
		g_assert_not_reached ();
#line 383 "Agent.c"
	}
	_state_0:
#line 28 "../src/Agent.vala"
	_data_->_data2_ = g_slice_new0 (Block2Data);
#line 28 "../src/Agent.vala"
	_data_->_data2_->_ref_count_ = 1;
#line 28 "../src/Agent.vala"
	_data_->_data2_->self = g_object_ref (_data_->self);
#line 28 "../src/Agent.vala"
	_data_->_data2_->_async_data_ = _data_;
#line 30 "../src/Agent.vala"
	if (_data_->identities == NULL) {
#line 31 "../src/Agent.vala"
		_data_->result = FALSE;
#line 31 "../src/Agent.vala"
		block2_data_unref (_data_->_data2_);
#line 31 "../src/Agent.vala"
		_data_->_data2_ = NULL;
#line 31 "../src/Agent.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 31 "../src/Agent.vala"
		if (_data_->_state_ != 0) {
#line 31 "../src/Agent.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 31 "../src/Agent.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 410 "Agent.c"
			}
		}
#line 31 "../src/Agent.vala"
		g_object_unref (_data_->_async_result);
#line 31 "../src/Agent.vala"
		return FALSE;
#line 417 "Agent.c"
	}
#line 34 "../src/Agent.vala"
	_data_->_tmp0_ = ag_polkit_dialog_new (_data_->message, _data_->icon_name, _data_->cookie, _data_->identities, _data_->cancellable);
#line 34 "../src/Agent.vala"
	g_object_ref_sink (_data_->_tmp0_);
#line 34 "../src/Agent.vala"
	_data_->dialog = _data_->_tmp0_;
#line 35 "../src/Agent.vala"
	_data_->_tmp1_ = _data_->dialog;
#line 35 "../src/Agent.vala"
	g_signal_connect_data (_data_->_tmp1_, "done", (GCallback) ___lambda8__ag_polkit_dialog_done, block2_data_ref (_data_->_data2_), (GClosureNotify) block2_data_unref, 0);
#line 37 "../src/Agent.vala"
	_data_->_tmp2_ = _data_->dialog;
#line 37 "../src/Agent.vala"
	gtk_window_present ((GtkWindow*) _data_->_tmp2_);
#line 38 "../src/Agent.vala"
	_data_->_state_ = 1;
#line 38 "../src/Agent.vala"
	return FALSE;
#line 437 "Agent.c"
	_state_1:
	;
#line 40 "../src/Agent.vala"
	_data_->_tmp3_ = _data_->dialog;
#line 40 "../src/Agent.vala"
	gtk_window_destroy ((GtkWindow*) _data_->_tmp3_);
#line 42 "../src/Agent.vala"
	_data_->_tmp4_ = _data_->dialog;
#line 42 "../src/Agent.vala"
	if (_data_->_tmp4_->was_canceled) {
#line 43 "../src/Agent.vala"
		_data_->_tmp5_ = g_error_new_literal (POLKIT_ERROR, POLKIT_ERROR_CANCELLED, "Authentication dialog was dismissed by the user");
#line 43 "../src/Agent.vala"
		_data_->_inner_error0_ = _data_->_tmp5_;
#line 43 "../src/Agent.vala"
		if (_data_->_inner_error0_->domain == POLKIT_ERROR) {
#line 43 "../src/Agent.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 43 "../src/Agent.vala"
			_g_object_unref0 (_data_->dialog);
#line 43 "../src/Agent.vala"
			block2_data_unref (_data_->_data2_);
#line 43 "../src/Agent.vala"
			_data_->_data2_ = NULL;
#line 43 "../src/Agent.vala"
			g_object_unref (_data_->_async_result);
#line 43 "../src/Agent.vala"
			return FALSE;
#line 466 "Agent.c"
		} else {
#line 43 "../src/Agent.vala"
			_g_object_unref0 (_data_->dialog);
#line 43 "../src/Agent.vala"
			block2_data_unref (_data_->_data2_);
#line 43 "../src/Agent.vala"
			_data_->_data2_ = NULL;
#line 43 "../src/Agent.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 43 "../src/Agent.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 43 "../src/Agent.vala"
			g_object_unref (_data_->_async_result);
#line 43 "../src/Agent.vala"
			return FALSE;
#line 482 "Agent.c"
		}
	}
#line 46 "../src/Agent.vala"
	_data_->result = TRUE;
#line 46 "../src/Agent.vala"
	_g_object_unref0 (_data_->dialog);
#line 46 "../src/Agent.vala"
	block2_data_unref (_data_->_data2_);
#line 46 "../src/Agent.vala"
	_data_->_data2_ = NULL;
#line 46 "../src/Agent.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 46 "../src/Agent.vala"
	if (_data_->_state_ != 0) {
#line 46 "../src/Agent.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 46 "../src/Agent.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 501 "Agent.c"
		}
	}
#line 46 "../src/Agent.vala"
	g_object_unref (_data_->_async_result);
#line 46 "../src/Agent.vala"
	return FALSE;
#line 508 "Agent.c"
}

AgAgent*
ag_agent_construct (GType object_type)
{
	AgAgent * self = NULL;
#line 27 "../src/Agent.vala"
	self = (AgAgent*) g_object_new (object_type, NULL);
#line 27 "../src/Agent.vala"
	return self;
#line 519 "Agent.c"
}

AgAgent*
ag_agent_new (void)
{
#line 27 "../src/Agent.vala"
	return ag_agent_construct (AG_TYPE_AGENT);
#line 527 "Agent.c"
}

static void
ag_agent_class_init (AgAgentClass * klass,
                     gpointer klass_data)
{
#line 27 "../src/Agent.vala"
	ag_agent_parent_class = g_type_class_peek_parent (klass);
#line 27 "../src/Agent.vala"
	((PolkitAgentListenerClass *) klass)->initiate_authentication = (void (*) (PolkitAgentListener*, const gchar*, const gchar*, const gchar*, PolkitDetails*, const gchar*, GList*, GCancellable*, GAsyncReadyCallback, gpointer)) ag_agent_real_initiate_authentication;
#line 27 "../src/Agent.vala"
	((PolkitAgentListenerClass *) klass)->initiate_authentication_finish = (gboolean (*) (PolkitAgentListener*, GAsyncResult*, GError**)) ag_agent_initiate_authentication_finish;
#line 540 "Agent.c"
}

static void
ag_agent_instance_init (AgAgent * self,
                        gpointer klass)
{
}

static GType
ag_agent_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (AgAgentClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) ag_agent_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AgAgent), 0, (GInstanceInitFunc) ag_agent_instance_init, NULL };
	GType ag_agent_type_id;
	ag_agent_type_id = g_type_register_static (polkit_agent_listener_get_type (), "AgAgent", &g_define_type_info, 0);
	return ag_agent_type_id;
}

GType
ag_agent_get_type (void)
{
	static volatile gsize ag_agent_type_id__once = 0;
	if (g_once_init_enter (&ag_agent_type_id__once)) {
		GType ag_agent_type_id;
		ag_agent_type_id = ag_agent_get_type_once ();
		g_once_init_leave (&ag_agent_type_id__once, ag_agent_type_id);
	}
	return ag_agent_type_id__once;
}

